<?php

/**
 * JCH Optimize - Aggregate and minify external resources for optmized downloads
 * 
 * @author Samuel Marshall <sdmarshall73@gmail.com>
 * @copyright Copyright (c) 2010 Samuel Marshall
 * @license GNU/GPLv3, See LICENSE file
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * If LICENSE file missing, see <http://www.gnu.org/licenses/>.
 */

class JchPlatformUtility implements JchInterfaceUtility
{
        public static function createFolder($path)
        {
                $file = new Varien_Io_File();
		
		return $file->mkdir($path, 0755);
        }

	public static function write($filename, $contents)
	{
		$file = new Varien_Io_File();
		$file->setAllowCreateFolders(true)->checkAndCreateFolder(dirname($filename), 0755);
			
		return $file->write($filename, $contents, 0644);	
	}

        public static function decrypt($value)
        {
                return Mage::helper('core')->decrypt(str_replace(' ', '+', $value));
        }

        public static function encrypt($value)
        {
                return Mage::helper('core')->encrypt($value);
        }

        public static function get($value, $default = '', $filter = 'cmd', $method = 'request')
        {
                $request = Mage::app()->getRequest()->get($value);
                
                if(!isset($request))
                {
                        return $default;
                }
                
                return $request;
        }

        public static function getLogsPath()
        {
                return Mage::getBaseDir('log') . DIRECTORY_SEPARATOR . 'jch_optimize.info.log';
        }

        public static function isMsieLT10()
        {
                if (isset($_SERVER['HTTP_USER_AGENT']) && strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE'))
                {
                        preg_match('#MSIE ([0-9.]+)#', $_SERVER['HTTP_USER_AGENT'], $version);

                        if ((int) $version[1] < 10)
                        {
                                return TRUE;
                        }
                }
                
                return FALSE;
        }

        public static function lnEnd()
        {
                return "\n";
        }

        public static function log($message, $priority, $filename)
        {
                Mage::log($message, constant('Zend_Log::' . $priority), 'jch_optimize.' . strtolower($priority) . '.logs', TRUE);
        }

        public static function menuId()
        {
                //Mage::getSingleton('cms/page')->getIdentifier() 
                return '';
        }

        public static function tab()
        {
                return "\t";
        }

        public static function translate($text)
        {
                return Mage::helper('jchoptimize')->__($text);
        }

        public static function unixCurrentDate()
        {
                return Mage::getModel('core/date')->timestamp(time());
        }

        public static function lsFiles($path, $filter = '.', $recurse = false, $exclude = array())
        {
		$files = new Varien_Directory_Collection($path, $recurse);
                $files->addFilter('extension', array('gif','jpg', 'jpeg','png')); 
		$files->useFilter(true);

		return $files->filesPaths();
        }

	public static function isGuest()
	{
	}

	public static function sendHeaders($headers)
	{
		if (!empty($headers))
		{
			foreach ($headers as $header => $value)
			{
				header($header . ': ' . $value);
			}
		}
	}
}
